import { Collection, Entity, ManyToOne, OneToMany, PrimaryKey, Property } from '@mikro-orm/core';
import { Character } from './character';
import { Sprite } from './sprite';
import { CharacterGender, CharacterRace } from '#utilities/enums';

@Entity()
export class CharacterType {
  @PrimaryKey()
  id!: number;

  @Property()
  name!: string;

  @Property()
  gender!: CharacterGender;

  @Property()
  race!: CharacterRace;

  @Property()
  isSelectable = false;

  @OneToMany(() => Character, character => character.characterType)
  characters = new Collection<Character>(this);

  @ManyToOne(() => Sprite, { nullable: true })
  sprite?: Sprite;

  @Property()
  createdAt = new Date();

  @Property()
  updatedAt = new Date();
}